diff -urN ../VisualBoyAdvance-1.7.2/src/win32/Reg.cpp ./src/win32/Reg.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/Reg.cpp	2004-05-13 23:18:44 +0900
+++ ./src/win32/Reg.cpp	2006-05-27 23:47:33 +0900
@@ -20,7 +20,7 @@
 
 static char buffer[2048];
 static HKEY vbKey = NULL;
-static CString regVbaPath;
+static CString *regVbaPath = NULL;
 
 #define VBA_PREF "preferences"
 
@@ -38,7 +38,12 @@
                             NULL,
                             &vbKey,
                             &disp);
-  regVbaPath.Format("%s\\vba.ini", path);
+  if( regVbaPath != NULL ) {
+	  delete regVbaPath;
+	  regVbaPath = NULL;
+  }
+  regVbaPath = new CString();
+  regVbaPath->Format("%s\\vba.ini", path);
 }
 
 void regShutdown()
@@ -48,7 +53,7 @@
 
 const char *regGetINIPath()
 {
-  return regVbaPath;
+  return *regVbaPath;
 }
 
 char *regQueryStringValue(const char * key, char *def)
@@ -75,7 +80,7 @@
                                       def,
                                       (LPTSTR)buffer,
                                       2048,
-                                      regVbaPath);
+                                      *regVbaPath);
 
   if(res)
     return buffer;
@@ -106,7 +111,7 @@
   return GetPrivateProfileInt(VBA_PREF,
                               key,
                               def,
-                              regVbaPath);
+                              *regVbaPath);
 }
 
 BOOL regQueryBinaryValue(const char * key, char *value, int count)
@@ -134,14 +139,14 @@
   int size = GetPrivateProfileInt(VBA_PREF,
                                   k,
                                   -1,
-                                  regVbaPath);
+                                  *regVbaPath);
   if(size >= 0 && size < count)
     count = size;
   return GetPrivateProfileStruct(VBA_PREF,
                                  key,
                                  value,
                                  count,
-                                 regVbaPath);
+                                 *regVbaPath);
 }
 
 void regSetStringValue(const char * key, const char * value)
@@ -152,12 +157,12 @@
                              NULL,
                              REG_SZ,
                              (const UCHAR *)value,
-                             strlen(value)+1);
+                             lstrlen(value)+1);
   } else {
     WritePrivateProfileString(VBA_PREF,
                               key,
                               value,
-                              regVbaPath);
+                              *regVbaPath);
   }
 }
 
@@ -175,7 +180,7 @@
     WritePrivateProfileString(VBA_PREF,
                               key,
                               buffer,
-                              regVbaPath);
+                              *regVbaPath);
   }
 }
 
@@ -196,13 +201,13 @@
     WritePrivateProfileString(VBA_PREF,
                               k,
                               buffer,
-                              regVbaPath);
+                              *regVbaPath);
                            
     WritePrivateProfileStruct(VBA_PREF,
                               key,
                               value,
                               count,
-                              regVbaPath);
+                              *regVbaPath);
   }
 }
 
@@ -215,7 +220,7 @@
     WritePrivateProfileString(VBA_PREF,
                               key,
                               NULL,
-                              regVbaPath);
+                              *regVbaPath);
   }
 }
 
@@ -238,7 +243,7 @@
                         0,
                         REG_SZ,
                         (const UCHAR *)type,
-                        strlen(type)+1);
+                        lstrlen(type)+1);
     RegCloseKey(key);
     return true;
   }
@@ -264,7 +269,7 @@
                         0,
                         REG_SZ,
                         (const UCHAR *)desc,
-                        strlen(desc)+1);
+                        lstrlen(desc)+1);
     HKEY key2;
     res = RegCreateKeyEx(key,
                          "Shell\\Open\\Command",
@@ -281,7 +286,7 @@
                           0,
                           REG_SZ,
                           (const UCHAR *)application,
-                          strlen(application)+1);
+                          lstrlen(application)+1);
       RegCloseKey(key2);
       RegCloseKey(key);
       return true;
@@ -318,14 +323,14 @@
           WritePrivateProfileString(section,
                                     valueName,
                                     temp,
-                                    regVbaPath);
+                                    *regVbaPath);
         }
         break;
       case REG_SZ:
         WritePrivateProfileString(section,
                                   valueName,
                                   buffer,
-                                  regVbaPath);
+                                  *regVbaPath);
         break;
       case REG_BINARY:
         {
@@ -337,12 +342,12 @@
           WritePrivateProfileString(section,
                                     k,
                                     temp,
-                                    regVbaPath);
+                                    *regVbaPath);
           WritePrivateProfileStruct(section,
                                     valueName,
                                     buffer,
                                     size,
-                                    regVbaPath);
+                                    *regVbaPath);
         }
         break;
       }
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/ResizeDlg.cpp ./src/win32/ResizeDlg.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/ResizeDlg.cpp	2003-11-04 23:09:52 +0900
+++ ./src/win32/ResizeDlg.cpp	2006-06-07 06:04:21 +0900
@@ -89,7 +89,7 @@
                        MB_ABORTRETRYIGNORE);
 
   if(res == IDRETRY) {
-    __asm int 3;
+	DebugBreak();
   } else if(res == IDABORT)
     SendMessage(*theApp.m_pMainWnd, WM_QUIT, 0, 0);
 }
@@ -143,7 +143,7 @@
   if(nCode == IDABORT) {
     ::SendMessage(*theApp.m_pMainWnd, WM_QUIT, 0, 0);
   } else if(nCode == IDRETRY)
-    __asm int 3;
+	  DebugBreak();
 }
 
 long FASTCALL RegQueryValueExRecursive( HKEY hKey, LPCTSTR lpValueName, LPDWORD lpReserved, LPDWORD lpType, LPBYTE lpData, LPDWORD lpcbData )
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/RomInfo.cpp ./src/win32/RomInfo.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/RomInfo.cpp	2004-05-13 23:18:06 +0900
+++ ./src/win32/RomInfo.cpp	2006-06-06 23:33:43 +0900
@@ -1,6 +1,6 @@
 // VisualBoyAdvance - Nintendo Gameboy/GameboyAdvance (TM) emulator.
 // Copyright (C) 1999-2003 Forgotten
-// Copyright (C) 2004 Forgotten and the VBA development team
+// Copyright (C) 2004-2006 Forgotten and the VBA development team
 
 // This program is free software; you can redistribute it and/or modify
 // it under the terms of the GNU General Public License as published by
@@ -356,6 +356,15 @@
   case 0x06:
     type = "ROM+MBC2+BATT";
     break;
+  case 0x0b:
+    type = "ROM+MMM01";
+    break;
+  case 0x0c:
+    type = "ROM+MMM01+RAM";
+    break;
+  case 0x0d:
+    type = "ROM+MMM01+RAM+BATT";
+    break;
   case 0x0f:
     type = "ROM+MBC3+TIMER+BATT";
     break;
@@ -392,6 +401,18 @@
   case 0x22:
     type = "ROM+MBC7+BATT";
     break;
+  case 0x55:
+    type = "GameGenie";
+    break;
+  case 0x56:
+    type = "GameShark V3.0";
+    break;
+  case 0xfc:
+    type = "ROM+POCKET CAMERA";
+    break;
+  case 0xfd:
+    type = "ROM+BANDAI TAMA5";
+    break;
   case 0xfe:
     type = "ROM+HuC-3";
     break;
@@ -533,7 +554,7 @@
 BOOL RomInfoGBA::OnInitDialog() 
 {
   CDialog::OnInitDialog();
-  
+
   char buffer[13];
 
   strncpy(buffer, (const char *)&rom[0xa0], 12);
@@ -554,6 +575,9 @@
   GetDlgItem(IDC_ROM_UNIT_CODE)->SetWindowText(buffer);
 
   sprintf(buffer, "%02x", rom[0xb4]);
+  if( rom[0xb4] & 0x80 ) {
+	  strcat(buffer, " (DACS)");
+  }
   GetDlgItem(IDC_ROM_DEVICE_TYPE)->SetWindowText(buffer);
 
   sprintf(buffer, "%02x", rom[0xbc]);
diff -urN ../VisualBoyAdvance-1.7.2/src/win32/TileView.cpp ./src/win32/TileView.cpp
--- ../VisualBoyAdvance-1.7.2/src/win32/TileView.cpp	2004-05-13 23:16:23 +0900
+++ ./src/win32/TileView.cpp	2006-06-07 06:04:21 +0900
@@ -265,38 +265,41 @@
 
 void TileView::OnSave() 
 {
-  CString captureBuffer;
+  if(rom != NULL)
+  {
+    CString captureBuffer;
+
+    if(theApp.captureFormat == 0)
+      captureBuffer = "tiles.png";
+    else
+      captureBuffer = "tiles.bmp";
+
+    LPCTSTR exts[] = {".png", ".bmp" };
+
+    CString filter = theApp.winLoadFilter(IDS_FILTER_PNG);
+    CString title = winResLoadString(IDS_SELECT_CAPTURE_NAME);
+
+    FileDlg dlg(this,
+                captureBuffer,
+                filter,
+                theApp.captureFormat ? 2 : 1,
+                theApp.captureFormat ? "BMP" : "PNG",
+                exts,
+                "",
+                title,
+                true);
 
-  if(theApp.captureFormat == 0)
-    captureBuffer = "tiles.png";
-  else
-    captureBuffer = "tiles.bmp";
-
-  LPCTSTR exts[] = {".png", ".bmp" };
-
-  CString filter = theApp.winLoadFilter(IDS_FILTER_PNG);
-  CString title = winResLoadString(IDS_SELECT_CAPTURE_NAME);
-
-  FileDlg dlg(this,
-              captureBuffer,
-              filter,
-              theApp.captureFormat ? 2 : 1,
-              theApp.captureFormat ? "BMP" : "PNG",
-              exts,
-              "",
-              title,
-              true);
-
-  if(dlg.DoModal() == IDCANCEL) {
-    return;
-  }
+    if(dlg.DoModal() == IDCANCEL) {
+      return;
+    }
 
-  captureBuffer = dlg.GetPathName();
+    captureBuffer = dlg.GetPathName();
 
-  if(dlg.getFilterIndex() == 2)
-    saveBMP(captureBuffer);
-  else
-    savePNG(captureBuffer);  
+    if(dlg.getFilterIndex() == 2)
+      saveBMP(captureBuffer);
+    else
+      savePNG(captureBuffer);
+  }
 }
 
 void TileView::renderTile256(int tile, int x, int y, u8 *charBase, u16 *palette)
@@ -526,8 +529,8 @@
   u8 *colors = (u8 *)lParam;
   zoom.setColors(colors);
 
-  int x = (wParam & 0xFFFF)/8;
-  int y = ((wParam >> 16) & 0xFFFF)/8;
+  int x = (int)((wParam & 0xFFFF) / 8);
+  int y = (int)(((wParam >> 16) & 0xFFFF) / 8);
 
   u32 address = 0x6000000 + 0x4000 * charBase;
   int tile = 32 * y + x;
